'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = getConfig;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _jsonfile = require('jsonfile');

var _lodashDefaultsdeep = require('lodash.defaultsdeep');

var _lodashDefaultsdeep2 = _interopRequireDefault(_lodashDefaultsdeep);

var _lodashIsplainobject = require('lodash.isplainobject');

var _lodashIsplainobject2 = _interopRequireDefault(_lodashIsplainobject);

var _defaultConfig = require('../defaultConfig');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

/**
 * @param  {string|object}  config - The file path of the config file or the config file
 * @return {Object}
 */

function getConfig(config) {
  var baseConfig = {};
  if (typeof config === 'string') {
    baseConfig = parseConfigFile(config);
  }
  if ((0, _lodashIsplainobject2['default'])(config)) {
    baseConfig = config;
  }

  return (0, _lodashDefaultsdeep2['default'])(baseConfig, _defaultConfig2['default']);
}

function parseConfigFile(fileName) {
  try {
    _fs2['default'].lstatSync(fileName);
  } catch (e) {
    return {};
  }
  return (0, _jsonfile.readFileSync)(fileName);
}
module.exports = exports['default'];