'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports['default'] = inlineRequiredProperties;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodashForeach = require('lodash.foreach');

var _lodashForeach2 = _interopRequireDefault(_lodashForeach);

var _lodashIsobject = require('lodash.isobject');

var _lodashIsobject2 = _interopRequireDefault(_lodashIsobject);

var _constants = require('../../constants');

/**
 * @warning mutate spec
 */

function inlineRequiredProperties(spec) {
  (0, _lodashForeach2['default'])(spec, function (child) {
    if ((0, _lodashIsobject2['default'])(child)) {
      inlineRequiredProperties(child);
    }
  });

  if (spec.type === 'object' && spec.required && Array.isArray(spec.required)) {
    spec.required.forEach(function (requiredProperty) {
      spec[_constants.PROPERTIES_KEY][requiredProperty].required = true;
    });
    delete spec.required;
  }

  return spec;
}

module.exports = exports['default'];